# PSemaphore Class Reference

This class defines a thread synchronisation object. More...

`#include <semaphor.h>`

Inheritance diagram for PSemaphore:

List of all members.

## Public Member Functions

unsigned | GetInitial () const
unsigned | GetMaxCount () const
Construction
| PSemaphore (unsigned initial, unsigned maximum)
| Create a new semaphore with maximum count and initial value specified.
| PSemaphore (const PSemaphore &)
| Create a new semaphore with the same initial and maximum values as the original.
| ~PSemaphore ()
| Destroy the semaphore.
Operations
virtual void | Wait ()
| If the semaphore count is > 0, decrement the semaphore and return.
virtual PBoolean | Wait (const PTimeInterval &timeout)
| If the semaphore count is > 0, decrement the semaphore and return.
virtual void | Signal ()
| If there are waiting (blocked) threads then unblock the first one that was blocked.
virtual PBoolean | WillBlock () const
| Determine if the semaphore would block if the Wait() function were called.

## Protected Member Functions

| PQUEUE (ThreadQueue, PThread)

## Protected Attributes

unsigned | initialVar
unsigned | maxCountVar
ThreadQueue | waitQueue

## Detailed Description

This class defines a thread synchronisation object.

This is in the form of a integer semaphore. The semaphore has a count and a maximum value. The various combinations of count and usage of the Wait() and Signal() functions determine the type of synchronisation mechanism to be employed.

The Wait() operation is that if the semaphore count is > 0, decrement the semaphore and return. If it is = 0 then wait (block).

The Signal() operation is that if there are waiting threads then unblock the first one that was blocked. If no waiting threads and the count is less than the maximum then increment the semaphore.

The most common is to create a mutual exclusion zone. A mutex is where a piece of code or data cannot be accessed by more than one thread at a time. To prevent this the PSemaphore is used in the following manner:

          PSemaphore mutex(1, 1);  // Maximum value of 1 and initial value of 1.

          ...

          mutex.Wait();

          ... critical section - only one thread at a time here.

          mutex.Signal();

          ...

The first thread will pass through the Wait() function, a second thread will block on that function until the first calls the Signal() function, releasing the second thread.

## Constructor & Destructor Documentation

PSemaphore::PSemaphore | ( | unsigned | initial,
|  | unsigned | maximum |
| ) |  |  |

Create a new semaphore with maximum count and initial value specified.

If the initial value is larger than the maximum value then is is set to the maximum value.

Parameters:

  initial | Initial value for semaphore count.
  maximum | Maximum value for semaphore count.

PSemaphore::PSemaphore | ( | const PSemaphore & |  | ) |

Create a new semaphore with the same initial and maximum values as the original.

PSemaphore::~PSemaphore | ( |  | ) |

Destroy the semaphore.

This will assert if there are still waiting threads on the semaphore.

## Member Function Documentation

unsigned PSemaphore::GetInitial | ( |  | ) | const`[inline]`

unsigned PSemaphore::GetMaxCount | ( |  | ) | const`[inline]`

PSemaphore::PQUEUE | ( | ThreadQueue | ,
|  | PThread |  |
| ) |  |  | `[protected]`

virtual void PSemaphore::Signal | ( |  | ) | `[virtual]`

If there are waiting (blocked) threads then unblock the first one that was blocked.

If no waiting threads and the count is less than the maximum then increment the semaphore.

Implements PSync.

Reimplemented in PSyncPointAck.

virtual PBoolean PSemaphore::Wait | ( | const PTimeInterval & | timeout | ) | `[virtual]`

If the semaphore count is > 0, decrement the semaphore and return.

If if is = 0 then wait (block) for the specified amount of time.

Returns:
  true if semaphore was signalled, false if timed out.

virtual void PSemaphore::Wait | ( |  | ) | `[virtual]`

If the semaphore count is > 0, decrement the semaphore and return.

If if is = 0 then wait (block).

Implements PSync.

virtual PBoolean PSemaphore::WillBlock | ( |  | ) | const`[virtual]`

Determine if the semaphore would block if the Wait() function were called.

Returns:
  true if semaphore will block when Wait() is called.

## Member Data Documentation

unsigned PSemaphore::initialVar `[protected]`

unsigned PSemaphore::maxCountVar `[protected]`

ThreadQueue PSemaphore::waitQueue `[protected]`

The documentation for this class was generated from the following file:

- semaphor.h